# Introduction to Python
This is a collection of Jupyter notebooks that is intended to provide an introduction to the Python programming language. Although this collection is aimed to the beginner data science student, I found it very useful for any beginner in python programming. All notebooks were developed and released by [IBM Cognitive Class](https://cognitiveclass.ai/), with some minors changes, organization and customizations provided by Vin Busquet.

These notebooks were adjusted by [Jakob Harzer](https://www.syscop.de/people/jakob-harzer) to be used in the Parameter Estimation and Modelling and System Identification courses at University of Freiburg.

### Python Basics

This section covers the python basics: print, import, types, expressions and strings.

| Lesson        | Estimated time needed |
| ------------- |:---------------------:|
| Your first program        | 10 min |
| Types                     | 10 min |
| Expressions and Variables | 10 min |
| String Operations         | 15 min |
| **Total** | **45 min** |

### Python Data Structures

This section covers the main Python data structures.


| Lesson        | Estimated time needed |
| ------------- |:---------------------:|
| Tuples       | 15 min |
| Lists        | 15 min |
| Dictionaries | 20 min |
| Sets         | 20 min |
| **Total** | **75 min** |

## Python Programming Fundamentals
This section covers the fundamentals of Python language, logic and control structures, functions, and object-oriented programming in Python.

| Lesson        | Estimated time needed |
| ------------- |:---------------------:|
| Conditions and Branching       | 20 min |
| Loops        | 20 min |
| Functions         | 40 min |
| **Total** | **80 min** |

### NumPy
This section covers an introduction to [NumPy](https://numpy.org/), the fundamental package for scientific computing with Python.

NumPy makes it easier to do many operations that are commonly performed in data science. The same operations are usually computationally faster and require less memory in NumPy compared to regular Python.

| Lesson        | Estimated time needed |
| ------------- |:---------------------:|
| 1D NumPy in Python       | 30 min |
| 2D NumPy in Python     | 20 min |
| **Total** | **50 min** |

## License

This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.


## Acknowledgments
* [Cognitive Class](https://cognitiveclass.ai/)
* [IBM Cloud](https://www.ibm.com/cloud)
* [Joseph Santarcangelo](https://www.linkedin.com/in/joseph-s-50398b136/)
* [Mavis Zhou](https://www.linkedin.com/in/jiahui-mavis-zhou-a4537814a/)
* [Python for Data Science and AI (Coursera)](https://www.coursera.org/learn/python-for-applied-data-science-ai)
* [Jupyter Notebook](https://jupyter.org/)
* [Google Colab](https://colab.research.google.com/)
* [Raph Trajano](https://github.com/raphtrajano)

And a special thanks to [Raph Trajano](https://github.com/raphtrajano) for reviewing and fixing the materials.

https://github.com/computationalcore/introduction-to-python
